#include <iostream>
#include "Birthday.h"

using namespace std;

int main()
{
    cout << "raw_ptr ..." << endl;
    Birthday *raw_ptr = new Birthday();
    cout << "*raw_ptr = " << *raw_ptr   << endl;

    cout << endl << "uniq_ptr1 and uniq_ptr2 ..." << endl;
    unique_ptr<Birthday> uniq_ptr1(new Birthday(2001, 1, 1));
    unique_ptr<Birthday> uniq_ptr2(nullptr);
    cout << "*uniq_ptr1 = " << *uniq_ptr1 << endl;

    cout << endl << "uniq_ptr2 = move(uniq_ptr1) ..." << endl;
    uniq_ptr2 = move(uniq_ptr1);
    if (uniq_ptr1 == nullptr) cout << "uniq_ptr1 is null" << endl;
    else                      cout << "*uniq_ptr1 = " << *uniq_ptr1 << endl;
    cout << "*uniq_ptr2 = " << *uniq_ptr2 << endl;

    function<void (Birthday *bptr)> delete_birthday = [] (Birthday *ptr)
    {
        cout << "Deleting " << *ptr << endl;
        delete ptr;
    };

    cout << endl << "uniq_ptr3 ..." << endl;
    unique_ptr<Birthday, decltype(delete_birthday)>
        uniq_ptr3(new Birthday(2003, 3, 3), delete_birthday);
    cout << "*uniq_ptr3 = " << *uniq_ptr3 << endl;

    cout << endl << "uniq_ptr4 ..." << endl;
    unique_ptr<Birthday> uniq_ptr4(nullptr);
    uniq_ptr4.reset(new Birthday(2004, 4, 4));
    cout << "*uniq_ptr4 = " << *uniq_ptr4 << endl;

    cout << endl << "uniq_ptr4.reset ..." << endl;
    uniq_ptr4.reset(new Birthday(2005, 5, 5));
    cout << "*uniq_ptr4 = " << *uniq_ptr4 << endl;

    cout << endl << "Program termination ..." << endl;
    return 0;
}
